//
// "This sample program is provided AS IS and may be used, executed, copied and modified without royalty payment by customer (a) for its own 
// instruction and study, (b) in order to develop applications designed to run with an IBM WebSphere product, either for customer's own internal use 
// or for redistribution by customer, as part of such an application, in customer's own products. "
//
// Product 5630-A36,  (C) COPYRIGHT International Business Machines Corp., 2001, 2002
// All Rights Reserved * Licensed Materials - Property of IBM
//
package com.ibm.websphere.samples.technologysamples.basiccalcthinclient;

import com.ibm.websphere.samples.technologysamples.ejb.stateless.basiccalculatorejb.*;
import com.ibm.websphere.samples.technologysamples.basiccalcclient.common.*;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import java.rmi.RemoteException;
import java.util.Properties;

public class BasicCalculatorClientThin extends BasicCalculatorClient
{
   
    /**
     * Initializes the BasicCalculatorClient by establishing a connection to the 
     * remote EJB's
     */
    public void init() throws javax.naming.NamingException, javax.ejb.CreateException, java.rmi.RemoteException {
        
        //Get the parameter for providerURL from the command line properties
        String providerUrl = System.getProperties().getProperty("java.naming.provider.url");
       
        //Get the parameter for InitialContextFactory from the command line properties
        String namingFactory = System.getProperties().getProperty("java.naming.factory.initial");
            
        // Get the JNDI context for our EJB Server
        Properties p = new Properties();
            
        //Supply the provider url of the server
        p.put(javax.naming.Context.PROVIDER_URL,providerUrl);
            
        //Supply the initial context factory
        p.put(javax.naming.Context.INITIAL_CONTEXT_FACTORY,namingFactory);

        // Create the initial context using our context properties
        System.out.print("--Creating InitialContext... ");
		InitialContext initCtx = new InitialContext(p);
		System.out.println("Done.");
		
		// Lookup the Home from JNDI
		System.out.print("--Looking-up Home... ");
        Object homeObject = initCtx.lookup("WSsamples/BasicCalculator");
		System.out.println("Done.");
		
		// Narrow to a real object
		System.out.print("--Narrowing... ");
		bcHome = (BasicCalculatorHome) javax.rmi.PortableRemoteObject.narrow(homeObject, BasicCalculatorHome.class);
		System.out.println("Done.");
		
		// Create the home
		System.out.print("--Creating Home... ");
		bc = bcHome.create( );
		System.out.println("Done.");
    }

}